package pug.render;

import nme.display.BitmapData;
import nme.geom.Rectangle;
import pug.model.effect.Effect;
import pug.model.symbol.SymbolImage;
import nme.display.Bitmap;

import nme.Assets;

/**
 * ...
 * @author Jarnik
 */
class RenderImage extends Render
{
	public var image:SymbolImage;
	public var bitmap:Bitmap;

	public function new( effect:Effect, image:SymbolImage ) {
		super( effect );
		this.image = image;
		addChild( bitmap = new Bitmap() );
		bitmap.bitmapData = image.frames[ 0 ];
        //bitmap.x = -image.frameWidth/2;
        //bitmap.y = -image.frameHeight / 2;
		frameCount = image.frames.length;
	}
	
	override public function render( frame:Int, applyTransforms:Bool = true ):Void {
		var imageFrame:Int = frame;
		if ( effect != null ) {
			imageFrame = effect.gizmoAttributes.params[ 0 ].getValues( frame )[ 0 ];
		}
		imageFrame = Std.int( imageFrame % image.frames.length );
		bitmap.bitmapData = image.frames[ imageFrame ];
		if ( effect != null ) {
			var smoothing:Array<Dynamic> = effect.gizmoAttributes.paramSmoothing.getValues( frame );
			bitmap.smoothing = smoothing[ 0 ];
		}
		updatePivot();
		bitmap.x = - pivot.x;
		bitmap.y = - pivot.y;
		super.render( frame, applyTransforms );
	}
	
	override public function hideContents():Void {
		bitmap.visible = false;
	}
	
	public override function getFixedSize():Rectangle {
		return new Rectangle( 0, 0, bitmap.bitmapData.width, bitmap.bitmapData.height );
	}
	
}
